unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  Vcl.StdCtrls, Vcl.ExtDlgs, Vcl.ComCtrls,

  JPEG,PNGImage,GIFImg;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Button2: TButton;

    procedure Button1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    nom : string;

    BMT : TBitMap;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  PIC  : TPicture;
begin
  if OpenPictureDialog1.Execute then begin
    nom := OpenPictureDialog1.FileName;

    PIC := TPicture.Create;
    try
      PIC.LoadFromFile(nom);

      BMT.Width  := PIC.Width;
      BMT.Height := PIC.Height;
      BMT.Canvas.Draw(0,0,PIC.Graphic);
      Image1.Picture.Assign(BMT);
    finally
      PIC.Free;
    end;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BMT := TBitMap.Create;
end;

procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);

var
 r,g,b : byte;
 pix   : TColor;

begin
  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  pix := BMT.Canvas.Pixels[X,Y];
  r := GetRValue(pix);
  g := GetGValue(pix);
  b := GetBValue(pix);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);
end;

// Negativo
procedure TForm1.Button2Click(Sender: TObject);
var
 r,g,b : byte;
 pix   : TColor;
 kx,ky,
 nx,ny : integer;
 lamb  : byte;

begin
   lamb := 255;

   nx := BMT.Width;
   ny := BMT.Height;

   // operacion del negativo
   for kx := 0 to nx-1 do
     for ky := 0 to ny-1 do begin
       pix := BMT.Canvas.Pixels[kx,ky];

       r := lamb - GetRValue(pix);
       g := lamb - GetGValue(pix);
       b := lamb - GetBValue(pix);

       pix := RGB(r,g,b);
       BMT.Canvas.Pixels[kx,ky] := pix;
     end;

   // mandar a la interfase
   Image1.Picture.Assign(BMT);

end;


end.
